use std::fs;

use config::Config;
use welcome_msg::print_startup_msg;

mod config;

#[allow(unused)]
mod error_reporting;
mod welcome_msg;

fn main() {
    // TODO: proper error handling
    let cfg = Config::read();

    if cfg.startup_msg {
        print_startup_msg();
    }

    let source =
        fs::read_to_string(cfg.source).expect("can't find source file lol handle me better please");

    let ir =
        ir::from_ron(&source).expect("aww failed to parse source to graph ir handle me better");

    let mut machine = cfg.evaluator.pick();
    machine.feed(ir);
    machine.eval_full();
}
